<template>
  <v-data-table
    :headers="getHeader(classe.typeEvaluations, singleEleve)"
    :items="evaluations"
    :no-data-text="'Pas d\'évaluations'"
    sort-by="eleve.nom"
    hide-default-footer
  >
    <template v-slot:[`item.date`]="{ item }">
      {{ new Date(item.date.seconds * 1000).toLocaleDateString() }}
    </template>
    <template v-slot:[`item.evaluation.coteToPourcentage`]="{ item }">
      <span
        v-if="!item.absent"
        :class="{
          'text-red-400': item.evaluation.coteToPourcentage < 50,
        }"
      >
        <ICountUp :endVal="item.evaluation.coteToPourcentage.toFixed(2)" />
        %</span
      >
    </template>

    <template v-slot:[`item.evaluation`]="{ item }">
      <span
        :class="{
          'text-red-400': item.evaluation === 'N.A.',
          'text-green-400': item.evaluation === 'A.',
          'text-yellow-400': item.evaluation === 'E.V.A.',
          'text-red-300 italic': item.absent,
        }"
      >
        {{ item.absent ? "Absent" : item.evaluation }}</span
      >
    </template>

    <template v-slot:[`item.evaluation.coteToText`]="{ item }">
      <span
        v-if="!item.absent"
        :class="{
          'text-red-400': item.evaluation.coteToPourcentage < 50,
        }"
        >{{ item.evaluation.coteToText }}</span
      >
      <span v-else class="italic">Absent</span>
    </template>
  </v-data-table>
</template>

<script>
import { getHeaders } from "../../store/utils";
import ICountUp from "vue-countup-v2";

export default {
  components: {
    ICountUp,
  },
  created() {
    if (!this.singleEleve)
      this.$emit("titleChanged", "Mes évaluations en " + this.savoir.nom);
  },
  beforeDestroy() {
    if (!this.singleEleve) this.$emit("titleChanged", "Mes évaluations");
  },
  data() {
    return {
      singleEleve: this.$attrs.singleEleve,
    };
  },
  methods: {
    getHeader: getHeaders,
  },
  computed: {
    evaluations() {
      return this.singleEleve
        ? this.$store.getters.evaluationsByEleveAndCompetence(
            this.eleve,
            this.competence
          )
        : this.$store.getters.evaluationsBySavoir(this.savoir);
    },
    classe() {
      return this.$store.getters.getOneClasse(this.$route.params.classeid);
    },
    competence() {
      return this.$store.getters.getOneCompetence(
        this.$route.params.competenceid
      );
    },
    savoir() {
      return this.$store.getters.getOneSavoir(this.$route.params.savoirid);
    },
    eleve() {
      return this.$store.getters.getOneEleve(this.$route.params.eleveid);
    },
  },
};
</script>

<style>
</style>